Index: LMDZ6/trunk/libf/phylmd/phys_output_write_mod.F90
===================================================================
--- LMDZ6/trunk/libf/phylmd/phys_output_write_mod.F90	(revision 4618)
+++ LMDZ6/trunk/libf/phylmd/phys_output_write_mod.F90	(revision 4619)
@@ -420,11 +420,7 @@
     USE netcdf, ONLY: nf90_fill_real
     USE print_control_mod, ONLY: prt_level,lunout
-
-
-#ifdef CPP_XIOS
     ! ug Pour les sorties XIOS
-    USE xios
-    USE wxios, ONLY: wxios_closedef, missing_val, wxios_set_context
-#endif
+    USE lmdz_xios
+    USE wxios, ONLY: wxios_closedef, missing_val_xios=>missing_val, wxios_set_context
     USE phys_cal_mod, ONLY : mth_len
 
@@ -484,7 +480,5 @@
 !$OMP THREADPRIVATE(kmax_100m)
     REAL :: x
-#ifndef CPP_XIOS
     REAL :: missing_val
-#endif
     REAL, PARAMETER :: un_jour=86400.
     CHARACTER(len=12) :: nvar    
@@ -513,11 +507,11 @@
  !   ENDIF
 
-#ifdef CPP_XIOS
-    CALL wxios_set_context
-#endif
-
-#ifndef CPP_XIOS
-    missing_val=missing_val_nf90
-#endif
+    IF (using_xios) CALL wxios_set_context
+
+    IF (using_xios) THEN
+      missing_val=missing_val_xios
+    ELSE
+      missing_val=missing_val_nf90
+    ENDIF
 
     IF (.NOT.vars_defined) THEN
@@ -554,16 +548,17 @@
     DO iinit=1, iinitend
 !      print *,'IFF iinit=', iinit, iinitend 
-#ifdef CPP_XIOS
-       !$OMP MASTER
-       IF (vars_defined) THEN
-          IF (prt_level >= 10) then
-             write(lunout,*)"phys_output_write: call xios_update_calendar, itau_w=",itau_w
-          ENDIF
-!          CALL xios_update_calendar(itau_w)
-          CALL xios_update_calendar(itap)
-       ENDIF
-       !$OMP END MASTER
-       !$OMP BARRIER
-#endif
+       IF (using_xios) THEN
+         !$OMP MASTER
+         IF (vars_defined) THEN
+            IF (prt_level >= 10) then
+               write(lunout,*)"phys_output_write: call xios_update_calendar, itau_w=",itau_w
+            ENDIF
+!            CALL xios_update_calendar(itau_w)
+            CALL xios_update_calendar(itap)
+         ENDIF
+         !$OMP END MASTER
+         !$OMP BARRIER
+       ENDIF
+
        ! On procède à l'écriture ou à la définition des nombreuses variables:
 !!! Champs 1D !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
@@ -588,38 +583,39 @@
        CALL histwrite_phy(o_contfracOR, pctsrf(:,is_ter))
 !
-#ifdef CPP_XIOS
-       CALL histwrite_phy("R_ecc",R_ecc)
-       CALL histwrite_phy("R_peri",R_peri)
-       CALL histwrite_phy("R_incl",R_incl)
-       CALL histwrite_phy("solaire",solaire)
-       CALL histwrite_phy(o_Ahyb, ap)
-       CALL histwrite_phy(o_Bhyb, bp)
-       CALL histwrite_phy(o_Ahyb_bounds, Ahyb_bounds)
-       CALL histwrite_phy(o_Bhyb_bounds, Bhyb_bounds)
-       CALL histwrite_phy(o_Ahyb_mid, aps)
-       CALL histwrite_phy(o_Bhyb_mid, bps)
-       CALL histwrite_phy(o_Ahyb_mid_bounds, Ahyb_mid_bounds)
-       CALL histwrite_phy(o_Bhyb_mid_bounds, Bhyb_mid_bounds)
-       CALL histwrite_phy(o_longitude, longitude_deg)
-       CALL histwrite_phy(o_latitude, latitude_deg)
+       IF (using_xios) THEN
+
+         CALL histwrite_phy("R_ecc",R_ecc)
+         CALL histwrite_phy("R_peri",R_peri)
+         CALL histwrite_phy("R_incl",R_incl)
+         CALL histwrite_phy("solaire",solaire)
+         CALL histwrite_phy(o_Ahyb, ap)
+         CALL histwrite_phy(o_Bhyb, bp)
+         CALL histwrite_phy(o_Ahyb_bounds, Ahyb_bounds)
+         CALL histwrite_phy(o_Bhyb_bounds, Bhyb_bounds)
+         CALL histwrite_phy(o_Ahyb_mid, aps)
+         CALL histwrite_phy(o_Bhyb_mid, bps)
+         CALL histwrite_phy(o_Ahyb_mid_bounds, Ahyb_mid_bounds)
+         CALL histwrite_phy(o_Bhyb_mid_bounds, Bhyb_mid_bounds)
+         CALL histwrite_phy(o_longitude, longitude_deg)
+         CALL histwrite_phy(o_latitude, latitude_deg)
 !
 #ifdef CPP_RRTM
-      IF (iflag_rrtm.EQ.1) THEN
-        DO ISW=1, NSW
-          WRITE(ch1,'(i1)') ISW
-!         zx_tmp_0d=RSUN(ISW)
-!         CALL histwrite_phy("rsun"//ch1,zx_tmp_0d)
-          CALL histwrite_phy("rsun"//ch1,RSUN(ISW))
-        ENDDO
-      ENDIF
+        IF (iflag_rrtm.EQ.1) THEN
+          DO ISW=1, NSW
+            WRITE(ch1,'(i1)') ISW
+  !         zx_tmp_0d=RSUN(ISW)
+  !         CALL histwrite_phy("rsun"//ch1,zx_tmp_0d)
+            CALL histwrite_phy("rsun"//ch1,RSUN(ISW))
+          ENDDO
+        ENDIF
 #endif
 !
-       CALL histwrite_phy("co2_ppm",co2_ppm)
-       CALL histwrite_phy("CH4_ppb",CH4_ppb)
-       CALL histwrite_phy("N2O_ppb",N2O_ppb)
-       CALL histwrite_phy("CFC11_ppt",CFC11_ppt)
-       CALL histwrite_phy("CFC12_ppt",CFC12_ppt)
+        CALL histwrite_phy("co2_ppm",co2_ppm)
+        CALL histwrite_phy("CH4_ppb",CH4_ppb)
+        CALL histwrite_phy("N2O_ppb",N2O_ppb)
+        CALL histwrite_phy("CFC11_ppt",CFC11_ppt)
+        CALL histwrite_phy("CFC12_ppt",CFC12_ppt)
 !
-#endif
+      ENDIF !using_xios
 
 !!! Champs 2D !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
@@ -884,36 +880,36 @@
 
 ! offline 
-#ifdef CPP_XIOS
-       IF (offline) THEN
-
-          coefh_stok(:,1)      = cdragh(:)
-          coefh_stok(:,2:klev) = coefh(:,2:klev, is_ave)
+       IF (using_xios) THEN
+         IF (offline) THEN
+
+            coefh_stok(:,1)      = cdragh(:)
+            coefh_stok(:,2:klev) = coefh(:,2:klev, is_ave)
           
-          CALL histwrite_phy('upwd_stok', upwd)
-          CALL histwrite_phy('t_stok', t)
-          CALL histwrite_phy('fm_th_stok', fm_therm(:,1:klev))
-          CALL histwrite_phy('en_th_stok', entr_therm)
-          CALL histwrite_phy('da_stok',da )
-          CALL histwrite_phy('mp_stok',mp )
-          CALL histwrite_phy('dnwd_stok', dnwd)
-          CALL histwrite_phy('wght_stok', wght_cvfd)
-          CALL histwrite_phy('coefh_stok', coefh_stok)
-          CALL histwrite_phy('yu1_stok', u1) 
-          CALL histwrite_phy('yv1_stok', v1)
-
-          DO k=1,klev
-             IF (k<10) THEN
-                WRITE(nvar,'(i1)') k
-             ELSE IF (k<100) THEN
-                WRITE(nvar,'(i2)') k
-             ELSE
-                WRITE(nvar,'(i3)') k
-             END IF
-             nvar='phi_lev'//trim(nvar)
-             CALL histwrite_phy(nvar,phi(:,:,k))
-          END DO
+            CALL histwrite_phy('upwd_stok', upwd)
+            CALL histwrite_phy('t_stok', t)
+            CALL histwrite_phy('fm_th_stok', fm_therm(:,1:klev))
+            CALL histwrite_phy('en_th_stok', entr_therm)
+            CALL histwrite_phy('da_stok',da )
+            CALL histwrite_phy('mp_stok',mp )
+            CALL histwrite_phy('dnwd_stok', dnwd)
+            CALL histwrite_phy('wght_stok', wght_cvfd)
+            CALL histwrite_phy('coefh_stok', coefh_stok)
+            CALL histwrite_phy('yu1_stok', u1) 
+            CALL histwrite_phy('yv1_stok', v1)
+
+            DO k=1,klev
+               IF (k<10) THEN
+                  WRITE(nvar,'(i1)') k
+               ELSE IF (k<100) THEN
+                  WRITE(nvar,'(i2)') k
+               ELSE
+                  WRITE(nvar,'(i3)') k
+               END IF
+               nvar='phi_lev'//trim(nvar)
+               CALL histwrite_phy(nvar,phi(:,:,k))
+            END DO
           
-       ENDIF
-#endif
+         ENDIF
+       ENDIF
 
 
@@ -1291,54 +1287,56 @@
 
 #ifdef CPP_IOIPSL
-#ifndef CPP_XIOS
-  IF (.NOT.ok_all_xml) THEN
-       ! ATTENTION, LES ANCIENS HISTWRITE ONT ETES CONSERVES EN ATTENDANT MIEUX:
-       ! Champs interpolles sur des niveaux de pression
-       DO iff=1, nfiles
-          ll=0
-          DO k=1, nlevSTD
-             bb2=clevSTD(k) 
-             IF (bb2.EQ."850".OR.bb2.EQ."700".OR. &
+       IF (.NOT. using_xios) THEN
+         IF (.NOT.ok_all_xml) THEN
+           ! ATTENTION, LES ANCIENS HISTWRITE ONT ETES CONSERVES EN ATTENDANT MIEUX:
+           ! Champs interpolles sur des niveaux de pression
+            DO iff=1, nfiles
+              ll=0
+              DO k=1, nlevSTD
+                bb2=clevSTD(k) 
+                  IF (bb2.EQ."850".OR.bb2.EQ."700".OR. &
+                       bb2.EQ."500".OR.bb2.EQ."200".OR. &
+                       bb2.EQ."100".OR. &
+                       bb2.EQ."50".OR.bb2.EQ."10") THEN
+
+                      ! a refaire correctement !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+                      ll=ll+1
+                      CALL histwrite_phy(o_uSTDlevs(ll),uwriteSTD(:,k,iff), iff)
+                      CALL histwrite_phy(o_vSTDlevs(ll),vwriteSTD(:,k,iff), iff)
+                      CALL histwrite_phy(o_wSTDlevs(ll),wwriteSTD(:,k,iff), iff)
+                      CALL histwrite_phy(o_zSTDlevs(ll),phiwriteSTD(:,k,iff), iff)
+                      CALL histwrite_phy(o_qSTDlevs(ll),qwriteSTD(:,k,iff), iff)
+                      CALL histwrite_phy(o_tSTDlevs(ll),twriteSTD(:,k,iff), iff)
+
+                  ENDIF !(bb2.EQ."850".OR.bb2.EQ."700".OR.
+              ENDDO
+            ENDDO
+         ENDIF
+       ENDIF
+#endif
+
+       IF (using_xios) THEN
+         IF (ok_all_xml) THEN
+           !XIOS  CALL xios_get_field_attr("u850",default_value=missing_val)
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+            ll=0
+            DO k=1, nlevSTD
+              bb2=clevSTD(k) 
+              IF (bb2.EQ."850".OR.bb2.EQ."700".OR. &
                   bb2.EQ."500".OR.bb2.EQ."200".OR. &
                   bb2.EQ."100".OR. &
                   bb2.EQ."50".OR.bb2.EQ."10") THEN
-
-                ! a refaire correctement !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
-                ll=ll+1
-                CALL histwrite_phy(o_uSTDlevs(ll),uwriteSTD(:,k,iff), iff)
-                CALL histwrite_phy(o_vSTDlevs(ll),vwriteSTD(:,k,iff), iff)
-                CALL histwrite_phy(o_wSTDlevs(ll),wwriteSTD(:,k,iff), iff)
-                CALL histwrite_phy(o_zSTDlevs(ll),phiwriteSTD(:,k,iff), iff)
-                CALL histwrite_phy(o_qSTDlevs(ll),qwriteSTD(:,k,iff), iff)
-                CALL histwrite_phy(o_tSTDlevs(ll),twriteSTD(:,k,iff), iff)
-
-             ENDIF !(bb2.EQ."850".OR.bb2.EQ."700".OR.
-          ENDDO
-       ENDDO
-  ENDIF
-#endif
-#endif
-#ifdef CPP_XIOS
-  IF (ok_all_xml) THEN
-!XIOS  CALL xios_get_field_attr("u850",default_value=missing_val)
-!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
-          ll=0
-          DO k=1, nlevSTD
-             bb2=clevSTD(k) 
-             IF (bb2.EQ."850".OR.bb2.EQ."700".OR. &
-                bb2.EQ."500".OR.bb2.EQ."200".OR. &
-                bb2.EQ."100".OR. &
-                bb2.EQ."50".OR.bb2.EQ."10") THEN
-                ll=ll+1
-                CALL histwrite_phy(o_uSTDlevs(ll),ulevSTD(:,k))
-                CALL histwrite_phy(o_vSTDlevs(ll),vlevSTD(:,k))
-                CALL histwrite_phy(o_wSTDlevs(ll),wlevSTD(:,k))
-                CALL histwrite_phy(o_zSTDlevs(ll),philevSTD(:,k))
-                CALL histwrite_phy(o_qSTDlevs(ll),qlevSTD(:,k))
-                CALL histwrite_phy(o_tSTDlevs(ll),tlevSTD(:,k))
-             ENDIF !(bb2.EQ."850".OR.bb2.EQ."700".OR.
-          ENDDO
-  ENDIF
-#endif
+                  ll=ll+1
+                  CALL histwrite_phy(o_uSTDlevs(ll),ulevSTD(:,k))
+                  CALL histwrite_phy(o_vSTDlevs(ll),vlevSTD(:,k))
+                  CALL histwrite_phy(o_wSTDlevs(ll),wlevSTD(:,k))
+                  CALL histwrite_phy(o_zSTDlevs(ll),philevSTD(:,k))
+                  CALL histwrite_phy(o_qSTDlevs(ll),qlevSTD(:,k))
+                  CALL histwrite_phy(o_tSTDlevs(ll),tlevSTD(:,k))
+              ENDIF !(bb2.EQ."850".OR.bb2.EQ."700".OR.
+            ENDDO
+         ENDIF
+       ENDIF
+
        IF (vars_defined) THEN
           DO i=1, klon
@@ -1789,18 +1787,18 @@
        ENDIF
 
-#ifdef CPP_XIOS
+       IF (using_xios) THEN
 !solbnd begin
 #ifdef CPP_RRTM
-      IF (iflag_rrtm.EQ.1) THEN
-       IF (vars_defined) THEN
-        DO ISW=1, NSW
-          zx_tmp_fi3dsp(:,ISW) = swdn(:,klevp1)*swradcorr(:)*RSUN(ISW)
-        ENDDO
-        CALL histwrite_phy(o_solbnd, zx_tmp_fi3dsp)
-       ENDIF
-      ENDIF
+         IF (iflag_rrtm.EQ.1) THEN
+           IF (vars_defined) THEN
+             DO ISW=1, NSW
+               zx_tmp_fi3dsp(:,ISW) = swdn(:,klevp1)*swradcorr(:)*RSUN(ISW)
+             ENDDO
+             CALL histwrite_phy(o_solbnd, zx_tmp_fi3dsp)
+           ENDIF
+         ENDIF
 #endif
 !solbnd end
-#endif
+       ENDIF
 #endif
 
@@ -2379,50 +2377,50 @@
 !!!!!!!!!!!! Sorties niveaux de pression NMC !!!!!!!!!!!!!!!!!!!!
 #ifdef CPP_IOIPSL
-#ifndef CPP_XIOS
-  IF (.NOT.ok_all_xml) THEN 
-       ! ATTENTION, LES ANCIENS HISTWRITE ONT ETES CONSERVES EN ATTENDANT MIEUX:
-       ! Champs interpolles sur des niveaux de pression
-       DO iff=7, nfiles-1 !--OB: here we deal with files 7,8,9
-
-          CALL histwrite_phy(o_tnondef,tnondef(:,:,iff-6),iff)
-          CALL histwrite_phy(o_ta,twriteSTD(:,:,iff-6),iff)
-          CALL histwrite_phy(o_zg,phiwriteSTD(:,:,iff-6),iff)
-          CALL histwrite_phy(o_hus,qwriteSTD(:,:,iff-6),iff)
-          CALL histwrite_phy(o_hur,rhwriteSTD(:,:,iff-6),iff)
-          CALL histwrite_phy(o_ua,uwriteSTD(:,:,iff-6),iff)
-          CALL histwrite_phy(o_va,vwriteSTD(:,:,iff-6),iff)
-          CALL histwrite_phy(o_wap,wwriteSTD(:,:,iff-6),iff)
-          IF (vars_defined) THEN
-             DO k=1, nlevSTD
-                DO i=1, klon
-                   IF (tnondef(i,k,iff-6).NE.missing_val) THEN
-                      IF (freq_outNMC(iff-6).LT.0) THEN
-                         freq_moyNMC(iff-6)=(mth_len*un_jour)/freq_calNMC(iff-6)
-                      ELSE
-                         freq_moyNMC(iff-6)=freq_outNMC(iff-6)/freq_calNMC(iff-6)
-                      ENDIF
-                      zx_tmp_fi3d_STD(i,k) = (100.*tnondef(i,k,iff-6))/freq_moyNMC(iff-6)
-                   ELSE
-                      zx_tmp_fi3d_STD(i,k) = missing_val
-                   ENDIF
-                ENDDO
-             ENDDO
-          ENDIF
-          CALL histwrite_phy(o_psbg,zx_tmp_fi3d_STD,iff)
-          IF (vars_defined) THEN
-             DO k=1, nlevSTD
-                DO i=1, klon
-                   IF (O3sumSTD(i,k,iff-6).NE.missing_val) THEN
-                      zx_tmp_fi3d_STD(i,k) = O3sumSTD(i,k,iff-6) * 1.e+9
-                   ELSE
-                      zx_tmp_fi3d_STD(i,k) = missing_val
-                   ENDIF
-                ENDDO
-             ENDDO !k=1, nlevSTD
-          ENDIF
-          CALL histwrite_phy(o_tro3,zx_tmp_fi3d_STD,iff)
-          IF (read_climoz == 2) THEN
+       IF (.NOT. using_xios) THEN
+         IF (.NOT.ok_all_xml) THEN 
+           ! ATTENTION, LES ANCIENS HISTWRITE ONT ETES CONSERVES EN ATTENDANT MIEUX:
+           ! Champs interpolles sur des niveaux de pression
+           DO iff=7, nfiles-1 !--OB: here we deal with files 7,8,9
+
+             CALL histwrite_phy(o_tnondef,tnondef(:,:,iff-6),iff)
+             CALL histwrite_phy(o_ta,twriteSTD(:,:,iff-6),iff)
+             CALL histwrite_phy(o_zg,phiwriteSTD(:,:,iff-6),iff)
+             CALL histwrite_phy(o_hus,qwriteSTD(:,:,iff-6),iff)
+             CALL histwrite_phy(o_hur,rhwriteSTD(:,:,iff-6),iff)
+             CALL histwrite_phy(o_ua,uwriteSTD(:,:,iff-6),iff)
+             CALL histwrite_phy(o_va,vwriteSTD(:,:,iff-6),iff)
+             CALL histwrite_phy(o_wap,wwriteSTD(:,:,iff-6),iff)
              IF (vars_defined) THEN
-                DO k=1, nlevSTD
+               DO k=1, nlevSTD
+                  DO i=1, klon
+                     IF (tnondef(i,k,iff-6).NE.missing_val) THEN
+                       IF (freq_outNMC(iff-6).LT.0) THEN
+                          freq_moyNMC(iff-6)=(mth_len*un_jour)/freq_calNMC(iff-6)
+                       ELSE
+                          freq_moyNMC(iff-6)=freq_outNMC(iff-6)/freq_calNMC(iff-6)
+                       ENDIF
+                       zx_tmp_fi3d_STD(i,k) = (100.*tnondef(i,k,iff-6))/freq_moyNMC(iff-6)
+                     ELSE
+                       zx_tmp_fi3d_STD(i,k) = missing_val
+                     ENDIF
+                  ENDDO
+               ENDDO
+             ENDIF
+             CALL histwrite_phy(o_psbg,zx_tmp_fi3d_STD,iff)
+             IF (vars_defined) THEN
+               DO k=1, nlevSTD
+                  DO i=1, klon
+                    IF (O3sumSTD(i,k,iff-6).NE.missing_val) THEN
+                       zx_tmp_fi3d_STD(i,k) = O3sumSTD(i,k,iff-6) * 1.e+9
+                    ELSE
+                       zx_tmp_fi3d_STD(i,k) = missing_val
+                    ENDIF
+                  ENDDO
+               ENDDO !k=1, nlevSTD
+             ENDIF
+             CALL histwrite_phy(o_tro3,zx_tmp_fi3d_STD,iff)
+             IF (read_climoz == 2) THEN
+               IF (vars_defined) THEN
+                 DO k=1, nlevSTD
                    DO i=1, klon
                       IF (O3daysumSTD(i,k,iff-6).NE.missing_val) THEN
@@ -2432,24 +2430,25 @@
                       ENDIF
                    ENDDO
-                ENDDO !k=1, nlevSTD
+                 ENDDO !k=1, nlevSTD
+               ENDIF
+               CALL histwrite_phy(o_tro3_daylight,zx_tmp_fi3d_STD,iff)
              ENDIF
-             CALL histwrite_phy(o_tro3_daylight,zx_tmp_fi3d_STD,iff)
-          endif
-          CALL histwrite_phy(o_uxv,uvsumSTD(:,:,iff-6),iff)
-          CALL histwrite_phy(o_vxq,vqsumSTD(:,:,iff-6),iff)
-          CALL histwrite_phy(o_vxT,vTsumSTD(:,:,iff-6),iff)
-          CALL histwrite_phy(o_wxq,wqsumSTD(:,:,iff-6),iff)
-          CALL histwrite_phy(o_vxphi,vphisumSTD(:,:,iff-6),iff)
-          CALL histwrite_phy(o_wxT,wTsumSTD(:,:,iff-6),iff)
-          CALL histwrite_phy(o_uxu,u2sumSTD(:,:,iff-6),iff)
-          CALL histwrite_phy(o_vxv,v2sumSTD(:,:,iff-6),iff)
-          CALL histwrite_phy(o_TxT,T2sumSTD(:,:,iff-6),iff)
-       ENDDO !nfiles
-  ENDIF
+             CALL histwrite_phy(o_uxv,uvsumSTD(:,:,iff-6),iff)
+             CALL histwrite_phy(o_vxq,vqsumSTD(:,:,iff-6),iff)
+             CALL histwrite_phy(o_vxT,vTsumSTD(:,:,iff-6),iff)
+             CALL histwrite_phy(o_wxq,wqsumSTD(:,:,iff-6),iff)
+             CALL histwrite_phy(o_vxphi,vphisumSTD(:,:,iff-6),iff)
+             CALL histwrite_phy(o_wxT,wTsumSTD(:,:,iff-6),iff)
+             CALL histwrite_phy(o_uxu,u2sumSTD(:,:,iff-6),iff)
+             CALL histwrite_phy(o_vxv,v2sumSTD(:,:,iff-6),iff)
+             CALL histwrite_phy(o_TxT,T2sumSTD(:,:,iff-6),iff)
+           ENDDO !nfiles
+         ENDIF
+       ENDIF !.NOT. using_xios
 #endif
-#endif
-#ifdef CPP_XIOS
-  IF (ok_all_xml) THEN 
-!      DO iff=7, nfiles
+
+       IF (using_xios) THEN
+         IF (ok_all_xml) THEN 
+    !      DO iff=7, nfiles
 
 !         CALL histwrite_phy(o_tnondef,tnondef(:,:,3))
@@ -2514,6 +2513,6 @@
           CALL histwrite_phy(o_TxT,T2STD(:,:))
 !      ENDDO !nfiles
-  ENDIF
-#endif
+    ENDIF
+  ENDIF !using_xios
 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
        IF (iflag_phytrac == 1 ) then
@@ -2698,8 +2697,7 @@
           ENDDO !  iff
 #endif
-#ifdef CPP_XIOS
           !On finalise l'initialisation:
-          CALL wxios_closedef()
-#endif
+          IF (using_xios) CALL wxios_closedef()
+
           !$OMP END MASTER
           !$OMP BARRIER
Index: LMDZ6/trunk/libf/phylmd/physiq_mod.F90
===================================================================
--- LMDZ6/trunk/libf/phylmd/physiq_mod.F90	(revision 4618)
+++ LMDZ6/trunk/libf/phylmd/physiq_mod.F90	(revision 4619)
@@ -76,7 +76,5 @@
     USE vampir
     USE write_field_phy
-#ifdef CPP_XIOS
     USE wxios, ONLY: g_ctx, wxios_set_context
-#endif
     USE lscp_mod, ONLY : lscp
     USE lmdz_wake_ini, ONLY : wake_ini
@@ -134,11 +132,9 @@
 #endif
 
-
-#ifdef CPP_XIOS
-    USE xios, ONLY: xios_update_calendar, xios_context_finalize
-    USE xios, ONLY: xios_get_field_attr, xios_field_is_active, xios_context
-    USE xios, ONLY: xios_set_current_context
-    USE wxios, ONLY: missing_val, missing_val_omp
-#endif
+    USE lmdz_xios, ONLY: xios_update_calendar, xios_context_finalize
+    USE lmdz_xios, ONLY: xios_get_field_attr, xios_field_is_active, xios_context
+    USE lmdz_xios, ONLY: xios_set_current_context
+    USE wxios, ONLY: missing_val, using_xios
+
 #ifndef CPP_XIOS
     USE paramLMDZ_phy_mod
@@ -520,7 +516,4 @@
     REAL dtadd(klon,klev)
 
-#ifndef CPP_XIOS
-    REAL, SAVE :: missing_val=nf90_fill_real
-#endif
 !!   Variables moved to phys_local_var_mod
 !!    ! Variables pour le transport convectif
@@ -1276,11 +1269,13 @@
     CALL update_time(pdtphys)
     phys_tstep=NINT(pdtphys)
-#ifdef CPP_XIOS
-! switch to XIOS LMDZ physics context 
-    IF (.NOT. debut .AND. is_omp_master) THEN
-       CALL wxios_set_context()
-       CALL xios_update_calendar(itap+1)
-    ENDIF
-#endif
+    IF (.NOT. using_xios) missing_val=nf90_fill_real
+
+    IF (using_xios) THEN
+      ! switch to XIOS LMDZ physics context 
+      IF (.NOT. debut .AND. is_omp_master) THEN
+        CALL wxios_set_context()
+        CALL xios_update_calendar(itap+1)
+      ENDIF
+    ENDIF
 
     !======================================================================
@@ -1841,7 +1836,8 @@
 
 
-#ifdef CPP_XIOS
-       IF (is_omp_master) CALL xios_update_calendar(1)
-#endif
+       IF (using_xios) THEN
+         IF (is_omp_master) CALL xios_update_calendar(1)
+       ENDIF
+       
        IF(read_climoz>=1 .AND. create_etat0_limit) CALL regr_horiz_time_climoz(read_climoz,ok_daily_climoz)
        CALL create_etat0_limit_unstruct
@@ -2022,63 +2018,57 @@
        !=============================================================
 
-#ifdef CPP_XIOS
-       ! Get "missing_val" value from XML files (from temperature variable)
-       !$OMP MASTER
-       CALL xios_get_field_attr("temp",default_value=missing_val_omp)
-       !$OMP END MASTER
-       !$OMP BARRIER
-       missing_val=missing_val_omp
-#endif
-
-#ifdef CPP_XIOS 
-! Need to put this initialisation after phyetat0 as in the coupled model the XIOS context is only
-! initialised at that moment
-       ! Get "missing_val" value from XML files (from temperature variable)
-       !$OMP MASTER
-       CALL xios_get_field_attr("temp",default_value=missing_val_omp)
-       !$OMP END MASTER
-       !$OMP BARRIER
-       missing_val=missing_val_omp
+       IF (using_xios) THEN    
+         ! Get "missing_val" value from XML files (from temperature variable)
+         IF (is_omp_master) CALL xios_get_field_attr("temp",default_value=missing_val)
+         CALL bcast_omp(missing_val)
+       ENDIF
+
+       IF (using_xios) THEN    
+         ! Need to put this initialisation after phyetat0 as in the coupled model the XIOS context is only
+         ! initialised at that moment
+         ! Get "missing_val" value from XML files (from temperature variable)
+         IF (is_omp_master) CALL xios_get_field_attr("temp",default_value=missing_val)
+         CALL bcast_omp(missing_val)
        ! 
        ! Now we activate some double radiation call flags only if some
        ! diagnostics are requested, otherwise there is no point in doing this
-       IF (is_master) THEN
-         !--setting up swaero_diag to TRUE in XIOS case 
-         IF (xios_field_is_active("topswad").OR.xios_field_is_active("topswad0").OR. & 
-            xios_field_is_active("solswad").OR.xios_field_is_active("solswad0").OR. & 
-            xios_field_is_active("topswai").OR.xios_field_is_active("solswai").OR.  & 
-              (iflag_rrtm==1.AND.(xios_field_is_active("toplwad").OR.xios_field_is_active("toplwad0").OR. & 
-                                  xios_field_is_active("sollwad").OR.xios_field_is_active("sollwad0"))))  & 
-            !!!--for now these fields are not in the XML files so they are omitted 
-            !!!  xios_field_is_active("toplwai").OR.xios_field_is_active("sollwai") !))) & 
-            swaero_diag=.TRUE. 
+         IF (is_master) THEN
+           !--setting up swaero_diag to TRUE in XIOS case 
+           IF (xios_field_is_active("topswad").OR.xios_field_is_active("topswad0").OR. & 
+              xios_field_is_active("solswad").OR.xios_field_is_active("solswad0").OR. & 
+              xios_field_is_active("topswai").OR.xios_field_is_active("solswai").OR.  & 
+                (iflag_rrtm==1.AND.(xios_field_is_active("toplwad").OR.xios_field_is_active("toplwad0").OR. & 
+                                    xios_field_is_active("sollwad").OR.xios_field_is_active("sollwad0"))))  & 
+              !!!--for now these fields are not in the XML files so they are omitted 
+              !!!  xios_field_is_active("toplwai").OR.xios_field_is_active("sollwai") !))) & 
+              swaero_diag=.TRUE. 
  
-         !--setting up swaerofree_diag to TRUE in XIOS case 
-         IF (xios_field_is_active("SWdnSFCcleanclr").OR.xios_field_is_active("SWupSFCcleanclr").OR. &
-            xios_field_is_active("SWupTOAcleanclr").OR.xios_field_is_active("rsucsaf").OR.   &
-            xios_field_is_active("rsdcsaf") .OR. xios_field_is_active("LWdnSFCcleanclr").OR. &
-            xios_field_is_active("LWupTOAcleanclr")) &
-            swaerofree_diag=.TRUE. 
+           !--setting up swaerofree_diag to TRUE in XIOS case 
+           IF (xios_field_is_active("SWdnSFCcleanclr").OR.xios_field_is_active("SWupSFCcleanclr").OR. &
+              xios_field_is_active("SWupTOAcleanclr").OR.xios_field_is_active("rsucsaf").OR.   &
+              xios_field_is_active("rsdcsaf") .OR. xios_field_is_active("LWdnSFCcleanclr").OR. &
+              xios_field_is_active("LWupTOAcleanclr")) &
+              swaerofree_diag=.TRUE. 
  
-         !--setting up dryaod_diag to TRUE in XIOS case 
-         DO naero = 1, naero_tot-1
-          IF (xios_field_is_active("dryod550_"//name_aero_tau(naero))) dryaod_diag=.TRUE. 
-         ENDDO
-         !
-         !--setting up ok_4xCO2atm to TRUE in XIOS case 
-         IF (xios_field_is_active("rsut4co2").OR.xios_field_is_active("rlut4co2").OR. & 
-            xios_field_is_active("rsutcs4co2").OR.xios_field_is_active("rlutcs4co2").OR. &
-            xios_field_is_active("rsu4co2").OR.xios_field_is_active("rsucs4co2").OR. &
-            xios_field_is_active("rsd4co2").OR.xios_field_is_active("rsdcs4co2").OR. &
-            xios_field_is_active("rlu4co2").OR.xios_field_is_active("rlucs4co2").OR. &
-            xios_field_is_active("rld4co2").OR.xios_field_is_active("rldcs4co2")) &
-            ok_4xCO2atm=.TRUE. 
-       ENDIF
-       !$OMP BARRIER
-       CALL bcast(swaero_diag)
-       CALL bcast(swaerofree_diag)
-       CALL bcast(dryaod_diag)
-       CALL bcast(ok_4xCO2atm)
-#endif 
+           !--setting up dryaod_diag to TRUE in XIOS case 
+           DO naero = 1, naero_tot-1
+             IF (xios_field_is_active("dryod550_"//name_aero_tau(naero))) dryaod_diag=.TRUE. 
+           ENDDO
+           !
+          !--setting up ok_4xCO2atm to TRUE in XIOS case 
+           IF (xios_field_is_active("rsut4co2").OR.xios_field_is_active("rlut4co2").OR. & 
+              xios_field_is_active("rsutcs4co2").OR.xios_field_is_active("rlutcs4co2").OR. &
+              xios_field_is_active("rsu4co2").OR.xios_field_is_active("rsucs4co2").OR. &
+              xios_field_is_active("rsd4co2").OR.xios_field_is_active("rsdcs4co2").OR. &
+              xios_field_is_active("rlu4co2").OR.xios_field_is_active("rlucs4co2").OR. &
+              xios_field_is_active("rld4co2").OR.xios_field_is_active("rldcs4co2")) &
+              ok_4xCO2atm=.TRUE. 
+           ENDIF
+           !$OMP BARRIER
+           CALL bcast(swaero_diag)
+           CALL bcast(swaerofree_diag)
+           CALL bcast(dryaod_diag)
+           CALL bcast(ok_4xCO2atm)
+         ENDIF !using_xios
        !
        CALL printflag( tabcntr0,radpas,ok_journe, &
@@ -4509,16 +4499,16 @@
           cool = cool + betalwoff * (cool0 - cool)
  
-#ifndef CPP_XIOS
-          !
-          !IM 2eme calcul radiatif pour le cas perturbe ou au moins un
-          !IM des taux doit etre different du taux actuel
-          !IM Par defaut on a les taux perturbes egaux aux taux actuels
-          !
-          IF (RCO2_per.NE.RCO2_act.OR. &
-              RCH4_per.NE.RCH4_act.OR. &
-              RN2O_per.NE.RN2O_act.OR. &
-              RCFC11_per.NE.RCFC11_act.OR. &
-              RCFC12_per.NE.RCFC12_act) ok_4xCO2atm =.TRUE. 
-#endif
+          IF (.NOT. using_xios) THEN
+            !
+            !IM 2eme calcul radiatif pour le cas perturbe ou au moins un
+            !IM des taux doit etre different du taux actuel
+            !IM Par defaut on a les taux perturbes egaux aux taux actuels
+            !
+            IF (RCO2_per.NE.RCO2_act.OR. &
+                RCH4_per.NE.RCH4_act.OR. &
+                RN2O_per.NE.RN2O_act.OR. &
+                RCFC11_per.NE.RCFC11_act.OR. &
+                RCFC12_per.NE.RCFC12_act) ok_4xCO2atm =.TRUE. 
+          ENDIF
    ! 
           IF (ok_4xCO2atm) THEN
@@ -5558,5 +5548,5 @@
 
 #ifndef CPP_XIOS
-    CALL write_paramLMDZ_phy(itap,nid_ctesGCM,ok_sync)
+      CALL write_paramLMDZ_phy(itap,nid_ctesGCM,ok_sync)
 #endif
 
@@ -5604,16 +5594,16 @@
        
        ENDIF
-#ifdef CPP_XIOS
-       IF (is_omp_master) CALL xios_context_finalize
+
+       IF (using_xios) THEN
+         IF (is_omp_master) CALL xios_context_finalize
 
 #ifdef INCA
-       if (type_trac == 'inca') then 
-          IF (is_omp_master .and. grid_type==unstructured) THEN 
-             CALL finalize_inca
-          ENDIF
-       endif
+         if (type_trac == 'inca') then 
+            IF (is_omp_master .and. grid_type==unstructured) THEN 
+               CALL finalize_inca
+            ENDIF
+         endif
 #endif
-
-#endif
+       ENDIF 
        WRITE(lunout,*) ' physiq fin, nombre de steps ou cvpas = 1 : ', Ncvpaseq1
     ENDIF
Index: LMDZ6/trunk/libf/phylmd/plevel.F90
===================================================================
--- LMDZ6/trunk/libf/phylmd/plevel.F90	(revision 4618)
+++ LMDZ6/trunk/libf/phylmd/plevel.F90	(revision 4619)
@@ -12,7 +12,5 @@
   USE phys_state_var_mod, ONLY: missing_val_nf90 
 #endif
-#ifdef CPP_XIOS
-  USE wxios, ONLY: missing_val
-#endif
+  USE wxios, ONLY: missing_val_xios => missing_val, using_xios
   IMPLICIT NONE
 
@@ -60,13 +58,12 @@
 
 ! REAL missing_val
-#ifndef CPP_XIOS
   REAL :: missing_val
-#endif
 
 ! missing_val = nf90_fill_real
-
-#ifndef CPP_XIOS
-      missing_val=missing_val_nf90
-#endif
+  IF (using_xios) THEN
+    missing_val = missing_val_xios
+  ELSE
+    missing_val=missing_val_nf90
+  ENDIF
 
   IF (first) THEN
Index: LMDZ6/trunk/libf/phylmd/plevel_new.F90
===================================================================
--- LMDZ6/trunk/libf/phylmd/plevel_new.F90	(revision 4618)
+++ LMDZ6/trunk/libf/phylmd/plevel_new.F90	(revision 4619)
@@ -13,7 +13,5 @@
   USE phys_state_var_mod, ONLY: missing_val_nf90
 #endif
-#ifdef CPP_XIOS
-  USE wxios, ONLY: missing_val
-#endif
+  USE wxios, ONLY: missing_val_xios=>missing_val, using_xios
 
   IMPLICIT NONE
@@ -62,14 +60,11 @@
   INTEGER i, k
 
-! REAL missing_val
-#ifndef CPP_XIOS
   REAL :: missing_val
-#endif
 
-! missing_val = nf90_fill_real
-
-#ifndef CPP_XIOS
-      missing_val=missing_val_nf90
-#endif
+  IF (using_xios) THEN
+    missing_val=missing_val_xios
+  ELSE
+    missing_val=missing_val_nf90
+  ENDIF
 
   IF (first) THEN
